=== modified file 'bzrlib/branch.py'
--- bzrlib/branch.py	2011-04-12 00:44:43 +0000
+++ bzrlib/branch.py	2011-04-19 13:56:32 +0000
@@ -2577,7 +2577,8 @@
         configured to check constraints on history, in which case this may not
         be permitted.
         """
-        revision_id = _mod_revision.ensure_null(revision_id)
+        if not revision_id or not isinstance(revision_id, basestring):
+            raise errors.InvalidRevisionId(revision_id=revision_id, branch=self)
         # this old format stores the full history, but this api doesn't
         # provide it, so we must generate, and might as well check it's
         # correct
@@ -2813,7 +2814,8 @@
 
     @needs_write_lock
     def set_last_revision_info(self, revno, revision_id):
-        revision_id = _mod_revision.ensure_null(revision_id)
+        if not revision_id or not isinstance(revision_id, basestring):
+            raise errors.InvalidRevisionId(revision_id=revision_id, branch=self)
         old_revno, old_revid = self.last_revision_info()
         if self._get_append_revisions_only():
             self._check_history_violation(revision_id)

=== modified file 'bzrlib/remote.py'
--- bzrlib/remote.py	2011-04-11 00:18:12 +0000
+++ bzrlib/remote.py	2011-04-19 13:56:32 +0000
@@ -3003,7 +3003,8 @@
         # XXX: These should be returned by the set_last_revision_info verb
         old_revno, old_revid = self.last_revision_info()
         self._run_pre_change_branch_tip_hooks(revno, revision_id)
-        revision_id = _mod_revision.ensure_null(revision_id)
+        if not revision_id or not isinstance(revision_id, basestring):
+            raise errors.InvalidRevisionId(revision_id=revision_id, branch=self)
         try:
             response = self._call('Branch.set_last_revision_info',
                 self._remote_path(), self._lock_token, self._repo_lock_token,

=== modified file 'bzrlib/tests/per_branch/test_revision_history.py'
--- bzrlib/tests/per_branch/test_revision_history.py	2010-02-10 17:52:08 +0000
+++ bzrlib/tests/per_branch/test_revision_history.py	2011-04-19 13:56:32 +0000
@@ -147,17 +147,14 @@
             a_branch.unlock()
 
     def test_set_last_revision_info_none(self):
-        """Passing None to revision_info to None sets it to NULL_REVISION."""
+        """Passing None to set_last_revision_info raises an exception."""
         a_branch = self.get_branch()
         # Lock the branch, set the last revision info, then call
         # last_revision_info.
         a_branch.lock_write()
         self.addCleanup(a_branch.unlock)
-        self.callDeprecated(['NULL_REVISION should be used for the null'
-            ' revision instead of None, as of bzr 0.91.'],
+        self.assertRaises(errors.InvalidRevisionId,
             a_branch.set_last_revision_info, 0, None)
-        self.assertEqual((0, _mod_revision.NULL_REVISION),
-                         a_branch.last_revision_info())
 
     def test_set_last_revision_info_uncaches_revision_history_for_format6(self):
         """On format 6 branches, set_last_revision_info invalidates the revision

